// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include <ctime>
#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>
#include "init.hh"
#include "playfield.hh"
#include "intro.hh"
#include "game.hh"
#include "pingus.hh"
#include "pingu.hh"

char* 
PingusMain::get_title()
{
  return "Pingus";
}

void 
PingusMain::check_args(int argc, char* argv[])
{
  cout << "Checking arguments..." << endl; 
  cout << "Arguments correct" << endl;
}

void
PingusMain::intro(void)
{
  int x = 0;
  int flips = 0;

  cout << "Pingus Intro..." << endl;

  CL_Surface* menu;// = CL_SpriteProvider::create("menu", datafile);
  CL_Surface* menu_quit;// = CL_SpriteProvider::create("menu_quit", datafile);
  CL_Surface* menu_load;// = CL_SpriteProvider::create("menu_load", datafile);
  CL_Surface* menu_start;// = CL_SpriteProvider::create("menu_start", datafile);
  //CL_Display::set_palette("menu_pal", datafile);
  CL_Display::clear_display();
  menu->put_screen(0,0);
  CL_Display::flip_display();

  int  time = CL_System::get_time();
  int  pos = 0;
  int  temp_pos = pos;
 
  while(CL_Keyboard::get_keycode(CL_Keyboard::KEY_SPACE)==false) {
    CL_Display::flip_display();
    if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_UP) && pos < 3) {
      ++pos;
    } else if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_DOWN) && pos > (-1)) {
      --pos;
    }
	
    if (temp_pos != pos) {
      cout << pos << endl;
      CL_Display::clear_display();
      cout << "Clearing Display...." << endl;
      menu->put_screen(0,0);
	
      switch(pos) {
      case 0:
	menu_quit->put_screen(45,246);
	break;

      case 1:
	menu_load->put_screen(45,300);

	break;
	
      case 2:
	menu_start->put_screen(45,192);
	break;
      }
      CL_Display::flip_display();
      temp_pos = pos;
    }

    //    if (time + 1000 < CL_System::get_time()) {
    cout << "Flipping Display..." << endl;
    time = CL_System::get_time();
    //    }

    if (CL_System::keep_alive()) break;  
  }
}

int
PingusMain::play_level(int)
{
  bool quit = false;
  static int d=0;
      
  cout << "Starting Level" << endl;
  Playfield playfield;
  cout << "Playfield created" << endl;
      
  while(!quit) {
	
    if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_ESCAPE) == true) {
      quit = true;
    }

    if (/*mouse_b &*/ 1) {
      //show_mouse(NULL);
      //circlefill(playfield.world.gfx_map, mouse_x, mouse_y, 10, 0);
      //circlefill(playfield.world.col_map, mouse_x, mouse_y, 10, 0);
      //show_mouse(screen);
    } else if (/*mouse_b &*/ 2) {
      puts("New Pingu");
      //playfield.world.pingu.push_back(*(new Pingu(mouse_x, mouse_y)));
      puts("Happy Pinguing");
    } else if (/*mouse_b &*/ 3) {
      puts("Wrong Button");
    }
    //    cout << "Drawing Playfield" << endl;

    //cout << CL_Input::pointers[0]->get_cursor(0)->get_y() << endl;
    CL_System::keep_alive();

    // Do the game
    playfield.let_move();

    // Draw the game
    if (d == 3) {
      d = 0;
      CL_Display::clear_display();
      playfield.draw();
      CL_Display::flip_display();
    }
    ++d;
  }
}
  
int
PingusMain::main(int argc, char** argv)
{
  cout << "Pingus " << /*VERSION << */ " starting..." << endl;

  //PingusMain::check_args(argc, argv);

  // initialisation
  CL_System::init_display();
  CL_Display::set_videomode(800, 600, 8);
  
  datafile = CL_InputSourceProvider::create_datafile_provider("pingus.dat");

  cout << "Loading Data file...";
  CL_Surface* stopper = CL_SpriteProvider::create("Game/stopper", datafile);
  //CL_Surface* stopper = CL_Res_Surface::load("Game/sur_maptiles", datafile);
                           
  cout << "Starting: loading sprite..." << Pingu::sprite << endl;
  Pingu::sprite = CL_SpriteProvider::create("Game/sprite", datafile);
  Pingu::fall_sprite = CL_SpriteProvider::create("Game/stopper", datafile);

  /*  Pingu::walker.resize(3);
  Pingu::walker[0] = CL_SpriteProvider::create("Game/walker0", datafile);
  Pingu::walker[1] = CL_SpriteProvider::create("walker1", datafile);
  Pingu::walker[2] = CL_SpriteProvider::create("walker2", datafile);
  */
  Pingu::walker_a = CL_SpriteProvider::create("Game/walker", datafile);
  /*
  Pingu::walker_r.resize(3);
  Pingu::walker_r[0] = CL_SpriteProvider::create("walker_r0", datafile);
  Pingu::walker_r[1] = CL_SpriteProvider::create("walker_r1", datafile);
  Pingu::walker_r[2] = CL_SpriteProvider::create("walker_r2", datafile);
  */
  World::gfx_bg = CL_SpriteProvider::create("Game/gfx_bg", datafile);
  World::gfx_fg = CL_SpriteProvider::create("Game/gfx_fg", datafile);

  // CL_Display::set_palette("my_pal2", datafile);
  cout << "Finished: loading sprite... " << Pingu::sprite << endl;

  // CL_Sprite("stopper", datafile);  
  cout << "finished" << endl;

  int scr_width = CL_Display::get_width();
  int scr_height = CL_Display::get_height();

  //intro();

  cout << "Starting main loop" << endl;

  int x=0, y=0;
  
  //      while (CL_Keyboard::get_keycode(CL_Keyboard::KEY_ESCAPE) == false) {
  //    cout << CL_Input::mices[0]->get_mouse_x() << "--" 
  //	 << CL_Input::mices[0]->get_mouse_y() << endl;
  //stopper->put_screen(x,y);  
  srand(time(NULL));
  //ame();
  play_level(1);
  cout << "Looping" << endl;
  //	CL_System::keep_alive(); // Do NOT forget this one...
  // }
  return 0;
}

/* EOF */
