// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef PINGUTILEPROVIDER_HH
#define PINGUTILEPROVIDER_HH

#include <ClanLib/clanlib.h>
#include <vector>

// The Pingu TileProvider holds all tiles needed by Pingus. If a tile
// is requested it will return a pointer to the surface, if the surface
// is not allready loaded then it will be loaded.
// The main purpose of his class is to minimize memory usage and
// making tile managing easier.

class PinguTileProvider {
private:
  void new_surface(char*, CL_Surface*);
  CL_Surface* get_surface(char*);
public:
  vector<CL_Surface*>  surface;
  vector<char*>   surface_name;
};

#endif

/* EOF */
